searchNodes=[{"ref":"Distillery.Releases.App.html","title":"Distillery.Releases.App","type":"module","doc":"Represents important metadata about a given application."},{"ref":"Distillery.Releases.App.html#new/1","title":"Distillery.Releases.App.new/1","type":"function","doc":"Create a new Application struct from an application name"},{"ref":"Distillery.Releases.App.html#new/2","title":"Distillery.Releases.App.new/2","type":"function","doc":"Same as new/1, but specify the application&#39;s start type"},{"ref":"Distillery.Releases.App.html#valid_start_type?/1","title":"Distillery.Releases.App.valid_start_type?/1","type":"function","doc":"Determines if the provided start type is a valid one."},{"ref":"Distillery.Releases.App.html#t:start_type/0","title":"Distillery.Releases.App.start_type/0","type":"type","doc":""},{"ref":"Distillery.Releases.App.html#t:t/0","title":"Distillery.Releases.App.t/0","type":"type","doc":""},{"ref":"Distillery.Releases.Appup.html","title":"Distillery.Releases.Appup","type":"module","doc":"This module is responsible for generating appups between two releases."},{"ref":"Distillery.Releases.Appup.html#locate/3","title":"Distillery.Releases.Appup.locate/3","type":"function","doc":"Given an application name, and two versions, look for a custom appup which applies."},{"ref":"Distillery.Releases.Appup.html#make/6","title":"Distillery.Releases.Appup.make/6","type":"function","doc":"Generate a .appup for the given application, start version, and upgrade version. Parameters - application: the application name as an atom - v1: the previous version, such as &quot;0.0.1&quot; - v2: the new version, such as &quot;0.0.2&quot; - v1_path: the path to the v1 artifacts (rel/&lt;app&gt;/lib/&lt;app&gt;-0.0.1) - v2_path: the path to the v2 artifacts (_build/prod/lib/&lt;app&gt;)"},{"ref":"Distillery.Releases.Appup.html#t:app/0","title":"Distillery.Releases.Appup.app/0","type":"type","doc":""},{"ref":"Distillery.Releases.Appup.html#t:appup/0","title":"Distillery.Releases.Appup.appup/0","type":"type","doc":""},{"ref":"Distillery.Releases.Appup.html#t:appup_ver/0","title":"Distillery.Releases.Appup.appup_ver/0","type":"type","doc":""},{"ref":"Distillery.Releases.Appup.html#t:change/0","title":"Distillery.Releases.Appup.change/0","type":"type","doc":""},{"ref":"Distillery.Releases.Appup.html#t:dep_mods/0","title":"Distillery.Releases.Appup.dep_mods/0","type":"type","doc":""},{"ref":"Distillery.Releases.Appup.html#t:downgrade_instructions/0","title":"Distillery.Releases.Appup.downgrade_instructions/0","type":"type","doc":""},{"ref":"Distillery.Releases.Appup.html#t:instruction/0","title":"Distillery.Releases.Appup.instruction/0","type":"type","doc":""},{"ref":"Distillery.Releases.Appup.html#t:path_str/0","title":"Distillery.Releases.Appup.path_str/0","type":"type","doc":""},{"ref":"Distillery.Releases.Appup.html#t:upgrade_instructions/0","title":"Distillery.Releases.Appup.upgrade_instructions/0","type":"type","doc":""},{"ref":"Distillery.Releases.Appup.html#t:version_str/0","title":"Distillery.Releases.Appup.version_str/0","type":"type","doc":""},{"ref":"Distillery.Releases.Appup.Transform.html","title":"Distillery.Releases.Appup.Transform","type":"behaviour","doc":"A transform is an appup compilation pass which receives a list of appup instructions, along with metadata about those instructions, such as the source application, the source and target versions involved, and an optional list of configuration options for the transform. The job of a transform is to, well, apply a transformation to the instruction set, in order to accomplish some objective that one desires to be automated. A trivial example of one such transform would be a transform which ensures the purge mode is set to :soft_purge for all :update instructions. To see an example of such a transform, look in test/support/purge_transform.ex"},{"ref":"Distillery.Releases.Appup.Transform.html#down/5","title":"Distillery.Releases.Appup.Transform.down/5","type":"function","doc":"Applies all transforms against the current downgrade instruction. Additional information required as arguments and passed to transforms are the app the instruction applies to, and the source and target versions involved."},{"ref":"Distillery.Releases.Appup.Transform.html#c:down/5","title":"Distillery.Releases.Appup.Transform.down/5","type":"callback","doc":""},{"ref":"Distillery.Releases.Appup.Transform.html#up/5","title":"Distillery.Releases.Appup.Transform.up/5","type":"function","doc":"Applies all transforms against the current upgrade instruction. Additional information required as arguments and passed to transforms are the app the instruction applies to, and the source and target versions involved."},{"ref":"Distillery.Releases.Appup.Transform.html#c:up/5","title":"Distillery.Releases.Appup.Transform.up/5","type":"callback","doc":""},{"ref":"Distillery.Releases.Appup.Transform.html#t:app/0","title":"Distillery.Releases.Appup.Transform.app/0","type":"type","doc":""},{"ref":"Distillery.Releases.Appup.Transform.html#t:instruction/0","title":"Distillery.Releases.Appup.Transform.instruction/0","type":"type","doc":""},{"ref":"Distillery.Releases.Appup.Transform.html#t:options/0","title":"Distillery.Releases.Appup.Transform.options/0","type":"type","doc":""},{"ref":"Distillery.Releases.Appup.Transform.html#t:transform/0","title":"Distillery.Releases.Appup.Transform.transform/0","type":"type","doc":""},{"ref":"Distillery.Releases.Appup.Transform.html#t:version/0","title":"Distillery.Releases.Appup.Transform.version/0","type":"type","doc":""},{"ref":"Distillery.Releases.Appup.TransformError.html","title":"Distillery.Releases.Appup.TransformError","type":"exception","doc":"This error is raised when an appup transformation results in an invalid appup instruction or instruction set."},{"ref":"Distillery.Releases.Archiver.html","title":"Distillery.Releases.Archiver","type":"module","doc":"This module is responsible for packaging a release into a tarball."},{"ref":"Distillery.Releases.Archiver.html#archive/1","title":"Distillery.Releases.Archiver.archive/1","type":"function","doc":"Given an assembled release, and the Release struct representing it, this function will package up the release into a tar.gz file. It returns {:ok, &quot;path/to/tarball&quot;}, or {:error, reason}"},{"ref":"Distillery.Releases.Assembler.html","title":"Distillery.Releases.Assembler","type":"module","doc":"This module is responsible for assembling a release based on a Distillery.Releases.Config struct. It creates the release directory, copies applications, and generates release-specific files required by :systools and :release_handler."},{"ref":"Distillery.Releases.Assembler.html#apply_environment/2","title":"Distillery.Releases.Assembler.apply_environment/2","type":"function","doc":""},{"ref":"Distillery.Releases.Assembler.html#assemble/1","title":"Distillery.Releases.Assembler.assemble/1","type":"function","doc":"This function takes a Config struct and assembles the release. Note: This operation has side-effects! It creates files, directories, copies files from other filesystem locations. If failures occur, no cleanup of files/directories is performed. However, all files/directories created by this function are scoped to the current project&#39;s rel directory, and cannot impact the filesystem outside of this directory."},{"ref":"Distillery.Releases.Checks.html","title":"Distillery.Releases.Checks","type":"behaviour","doc":"This module defines a behavior for, and orchestrator of, static analysis checks to be performed at release-time. These checks are intended to operate on the fully reified release configuration and metadata, and return warnings, errors, or ok for the release assembler to react to. In most cases, warnings will be printed but assembly will continue; errors will be printed but will terminate assembly, and a successful check will be printed only if verbose logging is enabled."},{"ref":"Distillery.Releases.Checks.html#list/0","title":"Distillery.Releases.Checks.list/0","type":"function","doc":"Returns a list of all checks available to be applied."},{"ref":"Distillery.Releases.Checks.html#run/1","title":"Distillery.Releases.Checks.run/1","type":"function","doc":"Runs all default and configured checks against the given release."},{"ref":"Distillery.Releases.Checks.html#c:run/1","title":"Distillery.Releases.Checks.run/1","type":"callback","doc":""},{"ref":"Distillery.Releases.Checks.html#run/2","title":"Distillery.Releases.Checks.run/2","type":"function","doc":"Runs all of the given checks, in the given order."},{"ref":"Distillery.Releases.Checks.html#t:warning/0","title":"Distillery.Releases.Checks.warning/0","type":"type","doc":""},{"ref":"Distillery.Releases.Checks.Cookie.html","title":"Distillery.Releases.Checks.Cookie","type":"module","doc":"Runs some basic validation of the distribution cookie configuration"},{"ref":"Distillery.Releases.Checks.Cookie.html#run/1","title":"Distillery.Releases.Checks.Cookie.run/1","type":"function","doc":"Callback implementation for Distillery.Releases.Checks.run/1."},{"ref":"Distillery.Releases.Checks.Erts.html","title":"Distillery.Releases.Checks.Erts","type":"module","doc":"Validates the ERTS configuration for the given release"},{"ref":"Distillery.Releases.Checks.Erts.html#run/1","title":"Distillery.Releases.Checks.Erts.run/1","type":"function","doc":"Callback implementation for Distillery.Releases.Checks.run/1."},{"ref":"Distillery.Releases.Checks.LoadedOrphanedApps.html","title":"Distillery.Releases.Checks.LoadedOrphanedApps","type":"module","doc":"This check determines whether or not any of the applications in the release satisfy all three of the following conditions: Have a start type of :load or :none Are not included by any other application in the release (orphaned) Are expected to be started by at least one other application in the release, i.e. are present in the dependent application&#39;s :applications list. Such &quot;loaded-orphaned&quot; applications will result in a release which only partially boots, except in the rare case where the loaded applications are started before :init attempts to boot the dependents. If the loaded applications are not started before this point, the application controller will wait indefinitely for the loaded applications to be started, which will never occur because the thing which might have started them isn&#39;t started itself yet. In general this should be very rare, but has occurred, and can be very difficult to troubleshoot. This check provides information on how to work around the case where this happens, but the solutions are one of the following: Add these loaded applications, and their dependents, to included_applications in the releasing app. This requires that the releasing app take over the lifecycle of these applications, namely starting them during it&#39;s own start callback, generally by adding them to it&#39;s supervisor tree. Recommended only for those cases where it is absolutely required that the application be started at a particular point in time. Remove the :load start type from the applications which are orphaned, effectively allowing them to be started by :init when needed. This does imply that the application will be started, rather than simply loaded, which may not be desired - in such cases you need to evaluate the dependent applications to see whether they truly need to have the dependency started, or if they can be modified and remove it from their applications list. If neither of those work, you will need to use included_applications."},{"ref":"Distillery.Releases.Checks.LoadedOrphanedApps.html#run/1","title":"Distillery.Releases.Checks.LoadedOrphanedApps.run/1","type":"function","doc":"Callback implementation for Distillery.Releases.Checks.run/1."},{"ref":"Distillery.Releases.Config.html","title":"Distillery.Releases.Config","type":"module","doc":"Responsible for parsing the release configuration file."},{"ref":"Distillery.Releases.Config.html#current_version/1","title":"Distillery.Releases.Config.current_version/1","type":"macro","doc":"Gets the current version of the given app and returns it as a string. If the app cannot be loaded, an error is raised. Intended to be used in conjunction with setting the version of a release definition, as shown below. Usage release :myapp do set version: current_version(:myapp) end"},{"ref":"Distillery.Releases.Config.html#environment/2","title":"Distillery.Releases.Config.environment/2","type":"macro","doc":"Creates a new environment for building releases. Within an environment, you can set config options which apply to all releases built in that environment. Usage environment :dev do set dev_mode: true set include_erts: false end"},{"ref":"Distillery.Releases.Config.html#plugin/2","title":"Distillery.Releases.Config.plugin/2","type":"macro","doc":"Adds a plugin to the environment or release definition it is part of. Plugins will be called in the order they are defined. In the example below MyApp.ReleasePlugin will be called, then MyApp.MigratePlugin Usage release :myapp do plugin MyApp.ReleasePlugin plugin MyApp.MigratePlugin end"},{"ref":"Distillery.Releases.Config.html#read!/1","title":"Distillery.Releases.Config.read!/1","type":"function","doc":"Reads and validates a given configuration file. If the file does not exist, or an error occurs, a Distillery.Releases.Config.LoadError will be raised."},{"ref":"Distillery.Releases.Config.html#read_string!/1","title":"Distillery.Releases.Config.read_string!/1","type":"function","doc":"Reads and validates a string containing the contents of a config file. If an error occurs during reading, a Distillery.Releases.Config.LoadError will be raised."},{"ref":"Distillery.Releases.Config.html#release/2","title":"Distillery.Releases.Config.release/2","type":"macro","doc":"Creates a new release definition with the given name. Within a release definition, you can set config options specific to that release Usage release :myapp do set version: &quot;0.1.0&quot;, set applications: [:other_app] end"},{"ref":"Distillery.Releases.Config.html#set/1","title":"Distillery.Releases.Config.set/1","type":"macro","doc":"Set a config option within an environment or release definition. set takes a keyword list of one or more values to apply. An error will be raised if set is used outside of an environment or release definition, or if the config value being set does not exist. Usage environment :dev do set dev_mode: true end"},{"ref":"Distillery.Releases.Config.html#validate!/1","title":"Distillery.Releases.Config.validate!/1","type":"function","doc":"Validates a %Config{} struct. If the struct is not valid, an ArgumentError is raised. If valid, returns true."},{"ref":"Distillery.Releases.Config.html#t:t/0","title":"Distillery.Releases.Config.t/0","type":"type","doc":""},{"ref":"Distillery.Releases.Config.Provider.html","title":"Distillery.Releases.Config.Provider","type":"behaviour","doc":"This defines the behaviour for custom configuration providers."},{"ref":"Distillery.Releases.Config.Provider.html#expand_path/1","title":"Distillery.Releases.Config.Provider.expand_path/1","type":"function","doc":"Given a file path, this function expands it to an absolute path, while also expanding any environment variable references in the path. Examples iex&gt; var = String.replace(&quot;Elixir.Distillery.Releases.Config.Provider&quot;, &quot;.&quot;, &quot;_&quot;) ...&gt; System.put_env(var, &quot;hello&quot;) ...&gt; {:ok, &quot;var/hello/test&quot;} = Elixir.Distillery.Releases.Config.Provider.expand_path(&quot;var/${&quot; &lt;&gt; var &lt;&gt; &quot;}/test&quot;) iex&gt; {:ok, &quot;/&quot; &lt;&gt; _} = Elixir.Distillery.Releases.Config.Provider.expand_path(&quot;~/&quot;) iex&gt; {:error, :unclosed_var_expansion} = Elixir.Distillery.Releases.Config.Provider.expand_path(&quot;var/${FOO/test&quot;)"},{"ref":"Distillery.Releases.Config.Provider.html#c:init/1","title":"Distillery.Releases.Config.Provider.init/1","type":"callback","doc":"Called when the provider is initialized. Providers are invoked pre-boot, in a dedicated VM, with all application code loaded, and kernel, stdlib, compiler, and elixir applications started. Providers must use this callback to push configuration into the application environment, which will be persisted to a final sys.config for the release itself. The arguments given to init/1 are the same as given in the config_providers setting in your release configuration file."},{"ref":"Distillery.Releases.Config.Providers.Elixir.html","title":"Distillery.Releases.Config.Providers.Elixir","type":"module","doc":"Provides support for Mix.Config config scripts, e.g. config.exs This provider expects a path to a config file to load during boot as an argument: set config_providers: [ {Distillery.Releases.Config.Providers.Elixir, [&quot;${RELEASE_ROOT_DIR}/config.exs&quot;]} ] The above configuration goes in a release or environment definition in rel/config.exs, and will result in the given path being expanded during boot, and evaluated using Mix.Config. Caveats Because much of Mix assumes it is operating in a Mix project context, there are some things you need to be aware of when using Mix.Config in releases: Mix APIs, other than Mix.Config itself, are not guaranteed to work, and most do not. This provider starts Mix when the provider runs, so you can call Mix.env, but it is an exception to the rule. Other functions are unlikely to work, so you should not rely on them being available. Mix.env always returns :prod, unless MIX_ENV is exported in the environment, in which case that value is used instead. The Mix project context is unavailable, as is your build environment, so Mix configs which invoke git or otherwise depend on that context, are not going to work. You need to use configs which are pared down to only reference the target environment (in general configs should be small anyway)."},{"ref":"Distillery.Releases.Config.Providers.Elixir.html#merge_config/1","title":"Distillery.Releases.Config.Providers.Elixir.merge_config/1","type":"function","doc":""},{"ref":"Distillery.Releases.Environment.html","title":"Distillery.Releases.Environment","type":"module","doc":"Represents a unique configuration for releases built in this environment."},{"ref":"Distillery.Releases.Environment.html#new/1","title":"Distillery.Releases.Environment.new/1","type":"function","doc":"Creates a new Environment with the given name"},{"ref":"Distillery.Releases.Environment.html#t:t/0","title":"Distillery.Releases.Environment.t/0","type":"type","doc":""},{"ref":"Distillery.Releases.Overlays.html","title":"Distillery.Releases.Overlays","type":"module","doc":"This module is responsible for applying overlays to a release, prior to packaging. Overlays are templated with EEx, with bindings set to the values configured in overlay_vars. There are some preconfigured overlay variables, namely: :erts_vsn - The version of ERTS used by this release :release_name - The name of the current release :release_version - The version of the current release For example, given a release named my_release, version 0.1.0: {:mkdir, &quot;releases/&lt;%= release_version %&gt;/foo&quot;} The above overlay will create a directory, rel/my_release/releases/0.1.0/foo. Overlay input paths are relative to the project root, but overlay output paths are relative to the root directory for the current release, which is why the directory is created in rel/my_release, and not in the project root."},{"ref":"Distillery.Releases.Overlays.html#apply/3","title":"Distillery.Releases.Overlays.apply/3","type":"function","doc":"Applies a list of overlays to the current release. Returns {:ok, output_paths} or {:error, details}, where details is one of the following: {:invalid_overlay, term} - a malformed overlay object {:template_str, desc} - templating an overlay parameter failed {:template_file, file, line, desc} - a template overlay failed {:overlay_failed, term, overlay} - applying an overlay failed"},{"ref":"Distillery.Releases.Overlays.html#template_file/2","title":"Distillery.Releases.Overlays.template_file/2","type":"function","doc":""},{"ref":"Distillery.Releases.Overlays.html#template_str/2","title":"Distillery.Releases.Overlays.template_str/2","type":"function","doc":""},{"ref":"Distillery.Releases.Overlays.html#t:overlay/0","title":"Distillery.Releases.Overlays.overlay/0","type":"type","doc":""},{"ref":"Distillery.Releases.Plugin.html","title":"Distillery.Releases.Plugin","type":"behaviour","doc":"This module provides a simple way to add additional processing to phases of the release assembly and archival. Implementing your own plugin To create a Distillery plugin, create a new module in which you use Distillery.Releases.Plugin. Then write implementations for the following callbacks: before_assembly/2 after_assembly/2 before_package/2 after_package/2 after_cleanup/2 The default implementation is to pass the original %Release{}. You will only need to implement the functions your plugin requires. When you use Distillery.Releases.Plugin, the following happens: Your module is marked with @behaviour Distillery.Releases.Plugin. The Distillery.Releases.Release struct is aliased to %Release{}. The functions debug/1, info/1, warn/1, notice/1, and error/1 are imported from Distillery.Releases.Shell. These should be used to present output to the user. The first four callbacks (before_assembly/2, after_assembly/2, before_package/2, and after_package/2) will each be passed the %Release{} struct and options passed to the plugin. You can return a modified struct, or nil. Any other return value will lead to runtime errors. after_cleanup/2 is only invoked on mix distillery.release.clean. It will be passed the command line arguments. The return value is not used. Example defmodule MyApp.PluginDemo do use Distillery.Releases.Plugin def before_assembly(%Release{} = release, _opts) do info &quot;This is executed just prior to assembling the release&quot; release # or nil end def after_assembly(%Release{} = release, _opts) do info &quot;This is executed just after assembling, and just prior to packaging the release&quot; release # or nil end def before_package(%Release{} = release, _opts) do info &quot;This is executed just before packaging the release&quot; release # or nil end def after_package(%Release{} = release, _opts) do info &quot;This is executed just after packaging the release&quot; release # or nil end def after_cleanup(_args, _opts) do info &quot;This is executed just after running cleanup&quot; :ok # It doesn&#39;t matter what we return here end end"},{"ref":"Distillery.Releases.Plugin.html#after_assembly/1","title":"Distillery.Releases.Plugin.after_assembly/1","type":"function","doc":"Run the after_assembly/2 callback of all plugins of release."},{"ref":"Distillery.Releases.Plugin.html#c:after_assembly/2","title":"Distillery.Releases.Plugin.after_assembly/2","type":"callback","doc":"Called after assembling the release. Should return a modified %Release{} or nil."},{"ref":"Distillery.Releases.Plugin.html#after_cleanup/2","title":"Distillery.Releases.Plugin.after_cleanup/2","type":"function","doc":"Run the after_cleanup/2 callback of all plugins of release."},{"ref":"Distillery.Releases.Plugin.html#c:after_cleanup/2","title":"Distillery.Releases.Plugin.after_cleanup/2","type":"callback","doc":"Called when the user invokes the mix distillery.release.clean task. The callback will be passed the command line arguments to mix distillery.release.clean. It should clean up the files the plugin created. The return value of this callback is ignored."},{"ref":"Distillery.Releases.Plugin.html#after_package/1","title":"Distillery.Releases.Plugin.after_package/1","type":"function","doc":"Run the after_package/2 callback of all plugins of release."},{"ref":"Distillery.Releases.Plugin.html#c:after_package/2","title":"Distillery.Releases.Plugin.after_package/2","type":"callback","doc":"Called after packaging the release. Should return a modified %Release{} or nil. When in dev_mode, the packaging phase is skipped."},{"ref":"Distillery.Releases.Plugin.html#before_assembly/1","title":"Distillery.Releases.Plugin.before_assembly/1","type":"function","doc":"Run the before_assembly/2 callback of all plugins of release."},{"ref":"Distillery.Releases.Plugin.html#c:before_assembly/2","title":"Distillery.Releases.Plugin.before_assembly/2","type":"callback","doc":"Called before assembling the release. Should return a modified %Release{} or nil."},{"ref":"Distillery.Releases.Plugin.html#before_package/1","title":"Distillery.Releases.Plugin.before_package/1","type":"function","doc":"Run the before_package/2 callback of all plugins of release."},{"ref":"Distillery.Releases.Plugin.html#c:before_package/2","title":"Distillery.Releases.Plugin.before_package/2","type":"callback","doc":"Called before packaging the release. Should return a modified %Release{} or nil. When in dev_mode, the packaging phase is skipped."},{"ref":"Distillery.Releases.Profile.html","title":"Distillery.Releases.Profile","type":"module","doc":"Represents the configuration profile for a specific environment and release. More generally, a release has a profile, as does an environment, and when determining the configuration for a release in a given environment, the environment profile overrides the release profile. Options :output_dir - The directory to place release artifacts (default: _build/&lt;env&gt;/rel/&lt;name&gt;) :vm_args - When set, defines the path to a vm.args template to use :cookie - The distribution cookie to use when one is not provided via alternate means :sys_config - When set, defines the path to a custom sys.config file to use in the release :no_dot_erlang - Determines whether or not to pass :no_dot_erlang to :systools :executable - When set, builds the release into a self-extracting tar archive. This setting can either be `true`, a keyword list of options implying `true`, or `false` :transient - One of the options possible for :executable. Sets the archive to remove all extracted contents once execution finishes. NOTE: Only removes the self-extracted directory. :erl_opts - A string containing command-line arguments to pass to erl when running the release. :run_erl_env - A string containing environment variables to set when using run_erl :dev_mode - Assembles the release in a special development mode, optimized for quick feedback loops; rather than copying files to the output directory, they are symlinked, avoiding the expensive copies, and allowing one to run mix compile, restart the release, and have the changes be picked up. Disables archival of the release, and is not intended for deployment use, only development and testing. :include_erts - Sets the strategy for locating ERTS in a release to one of the following: true - Bundles the current ERTS into the release (located by asking erl where it lives) false - Skips bundling an ERTS completely, but requires that one be provided on the target system &quot;path/to/erlang&quot; - As indicated, a path to the ERTS you wish to bundle. Useful for cross-compiling. This path can be found with :code.root_dir() :include_src - Boolean indicating whether to bundle source files in the release. (default: false) :config_providers - A list of custom configuration providers to use. See Distillery.Releases.Config.Provider for details. :included_configs - Used to set paths for additional sys.config files to include at runtime, e.g. [&quot;/etc/sys.config&quot;] :appup_transforms - A list of custom appup transforms to apply when building upgrades: e.g. [MyTransform, {MyTransform, [:foo]}] :strip_debug_info - Boolean indicating whether to strip debug information from BEAM files (default: false) :plugins - A list of custom release plugins. See Distillery.Releases.Plugin for details :overlay_vars - A list of variables to expose to overlays and templates. Must be a Keyword list :overlays - A list of overlays to apply. See Distillery.Releases.Overlays for details. :overrides - A list of overrides for Distillery-provided overlay vars :commands - A list of custom commands to add to the release, e.g. [migrate: &quot;rel/scripts/migrate.sh&quot;] Hooks The following options all take a path to a directory containing the scripts which will be executed at the given point in the release lifecycle: :pre_configure_hooks - Executed before the system has generated config files :post_configure_hooks - Executed after config files have been generated :pre_start_hooks - Executed before the release is started :post_start_hooks - Executed after the release is started :pre_stop_hooks - Executed before the release is stopped :post_stop_hooks - Executed after the release is stopped :pre_upgrade_hooks - Executed before a release upgrade is installed :post_upgrade_hooks - Executed after a release upgrade is installed"},{"ref":"Distillery.Releases.Profile.html#t:t/0","title":"Distillery.Releases.Profile.t/0","type":"type","doc":""},{"ref":"Distillery.Releases.Release.html","title":"Distillery.Releases.Release","type":"module","doc":"Represents metadata about a release"},{"ref":"Distillery.Releases.Release.html#apps/1","title":"Distillery.Releases.Release.apps/1","type":"function","doc":"Gets a list of {app, vsn} tuples for the current release. An optional second parameter enables/disables debug logging of discovered apps."},{"ref":"Distillery.Releases.Release.html#archive_path/1","title":"Distillery.Releases.Release.archive_path/1","type":"function","doc":"Get the path to which the release tarball will be output"},{"ref":"Distillery.Releases.Release.html#bin_path/1","title":"Distillery.Releases.Release.bin_path/1","type":"function","doc":"Get the path to which release binaries will be output"},{"ref":"Distillery.Releases.Release.html#executable?/1","title":"Distillery.Releases.Release.executable?/1","type":"function","doc":"Returns true if the release is executable"},{"ref":"Distillery.Releases.Release.html#get/3","title":"Distillery.Releases.Release.get/3","type":"function","doc":"Load a fully configured Release object given a release name and environment name."},{"ref":"Distillery.Releases.Release.html#get_code_paths/1","title":"Distillery.Releases.Release.get_code_paths/1","type":"function","doc":"Returns a list of all code_paths of all applications included in the release"},{"ref":"Distillery.Releases.Release.html#lib_path/1","title":"Distillery.Releases.Release.lib_path/1","type":"function","doc":"Get the path to which compiled applications will be output"},{"ref":"Distillery.Releases.Release.html#new/3","title":"Distillery.Releases.Release.new/3","type":"function","doc":"Creates a new Release with the given name, version, and applications."},{"ref":"Distillery.Releases.Release.html#to_resource/1","title":"Distillery.Releases.Release.to_resource/1","type":"function","doc":"Converts a Release struct to a release resource structure. The format of release resources is documented in the Erlang manual"},{"ref":"Distillery.Releases.Release.html#version_path/1","title":"Distillery.Releases.Release.version_path/1","type":"function","doc":"Get the path to which versioned release data will be output"},{"ref":"Distillery.Releases.Release.html#t:app_resource/0","title":"Distillery.Releases.Release.app_resource/0","type":"type","doc":""},{"ref":"Distillery.Releases.Release.html#t:resource/0","title":"Distillery.Releases.Release.resource/0","type":"type","doc":""},{"ref":"Distillery.Releases.Release.html#t:t/0","title":"Distillery.Releases.Release.t/0","type":"type","doc":""},{"ref":"Distillery.Releases.Runtime.Control.html","title":"Distillery.Releases.Runtime.Control","type":"module","doc":"This module defines the tooling for interacting with nodes, as well as other utility functions of use."},{"ref":"Distillery.Releases.Runtime.Control.html#describe/2","title":"Distillery.Releases.Runtime.Control.describe/2","type":"function","doc":"Describes the current release"},{"ref":"Distillery.Releases.Runtime.Control.html#eval/2","title":"Distillery.Releases.Runtime.Control.eval/2","type":"function","doc":"Executes an expression or a file locally (i.e. not on the running node)"},{"ref":"Distillery.Releases.Runtime.Control.html#install/2","title":"Distillery.Releases.Runtime.Control.install/2","type":"function","doc":"Installs a release, unpacking if necessary"},{"ref":"Distillery.Releases.Runtime.Control.html#main/0","title":"Distillery.Releases.Runtime.Control.main/0","type":"function","doc":"Main entry point for this script. Handles parsing and validating arguments, then dispatching the selected command"},{"ref":"Distillery.Releases.Runtime.Control.html#parse_args/1","title":"Distillery.Releases.Runtime.Control.parse_args/1","type":"function","doc":""},{"ref":"Distillery.Releases.Runtime.Control.html#ping/2","title":"Distillery.Releases.Runtime.Control.ping/2","type":"function","doc":"Pings a peer node."},{"ref":"Distillery.Releases.Runtime.Control.html#pre_dispatch/3","title":"Distillery.Releases.Runtime.Control.pre_dispatch/3","type":"function","doc":"This function executes before any commands are dispatched"},{"ref":"Distillery.Releases.Runtime.Control.html#processes_info/2","title":"Distillery.Releases.Runtime.Control.processes_info/2","type":"function","doc":"Prints information about a remote node."},{"ref":"Distillery.Releases.Runtime.Control.html#reboot/2","title":"Distillery.Releases.Runtime.Control.reboot/2","type":"function","doc":"Reboots a peer node (this is a hard restart, emulator is restarted)"},{"ref":"Distillery.Releases.Runtime.Control.html#reload_config/2","title":"Distillery.Releases.Runtime.Control.reload_config/2","type":"function","doc":"Applies any pending configuration changes in config files to a peer node."},{"ref":"Distillery.Releases.Runtime.Control.html#restart/2","title":"Distillery.Releases.Runtime.Control.restart/2","type":"function","doc":"Restarts a peer node (this is a soft restart, emulator is left up)"},{"ref":"Distillery.Releases.Runtime.Control.html#rpc/2","title":"Distillery.Releases.Runtime.Control.rpc/2","type":"function","doc":"Executes an expression or a file on a remote node."},{"ref":"Distillery.Releases.Runtime.Control.html#stop/2","title":"Distillery.Releases.Runtime.Control.stop/2","type":"function","doc":"Stops a peer node"},{"ref":"Distillery.Releases.Runtime.Control.html#unpack/2","title":"Distillery.Releases.Runtime.Control.unpack/2","type":"function","doc":"Unpacks a release in preparation for it to be loaded"},{"ref":"Distillery.Releases.Runtime.Pidfile.html","title":"Distillery.Releases.Runtime.Pidfile","type":"module","doc":"This is a kernel process which will maintain a pidfile for the running node"},{"ref":"Distillery.Releases.Shell.html","title":"Distillery.Releases.Shell","type":"module","doc":"This module provides conveniences for writing output to the shell."},{"ref":"Distillery.Releases.Shell.html#colorf/2","title":"Distillery.Releases.Shell.colorf/2","type":"function","doc":"Wraps a message in the given color"},{"ref":"Distillery.Releases.Shell.html#configure/1","title":"Distillery.Releases.Shell.configure/1","type":"function","doc":"Configure the logging verbosity of the release logger. Valid verbosity settings are: * `:silent` - no output except errors * `:quiet` - no output except warnings/errors * `:normal` - no debug output (default) * `:verbose` - all output"},{"ref":"Distillery.Releases.Shell.html#confirm?/1","title":"Distillery.Releases.Shell.confirm?/1","type":"function","doc":"Ask the user to confirm an action using the given message. The confirmation prompt will default to &quot;[Yn]: &quot;, and the regex for determining whether the action was confirmed will default to &quot;^(y(es)?)?$&quot;. Use confirm/3 to provide your own prompt and answer regex."},{"ref":"Distillery.Releases.Shell.html#confirm?/3","title":"Distillery.Releases.Shell.confirm?/3","type":"function","doc":"Same as confirm/1, but takes a custom prompt and answer regex pattern. If the pattern matches the response, the action is considered confirmed."},{"ref":"Distillery.Releases.Shell.html#debug/1","title":"Distillery.Releases.Shell.debug/1","type":"function","doc":"Write an debug message to standard out."},{"ref":"Distillery.Releases.Shell.html#debugf/2","title":"Distillery.Releases.Shell.debugf/2","type":"function","doc":"Write a debug level message, but with minimal formatting. Default color is same as debug level"},{"ref":"Distillery.Releases.Shell.html#error/1","title":"Distillery.Releases.Shell.error/1","type":"function","doc":"Write an error message to standard out."},{"ref":"Distillery.Releases.Shell.html#fail!/1","title":"Distillery.Releases.Shell.fail!/1","type":"function","doc":"Prints an error message, then terminates the VM with a non-zero status code"},{"ref":"Distillery.Releases.Shell.html#info/1","title":"Distillery.Releases.Shell.info/1","type":"function","doc":"Write an info message to standard out."},{"ref":"Distillery.Releases.Shell.html#levelf/2","title":"Distillery.Releases.Shell.levelf/2","type":"function","doc":"Print a message formatted with the default formatting for the given log level"},{"ref":"Distillery.Releases.Shell.html#notice/1","title":"Distillery.Releases.Shell.notice/1","type":"function","doc":"Write an notice message to standard out."},{"ref":"Distillery.Releases.Shell.html#success/1","title":"Distillery.Releases.Shell.success/1","type":"function","doc":"Write an success message to standard out."},{"ref":"Distillery.Releases.Shell.html#verbosity/0","title":"Distillery.Releases.Shell.verbosity/0","type":"function","doc":"Returns the current verbosity setting"},{"ref":"Distillery.Releases.Shell.html#warn/1","title":"Distillery.Releases.Shell.warn/1","type":"function","doc":"Write an warn message to standard out."},{"ref":"Distillery.Releases.Shell.html#write/1","title":"Distillery.Releases.Shell.write/1","type":"function","doc":"Write the given iodata directly, bypassing the log level"},{"ref":"Distillery.Releases.Shell.html#writef/2","title":"Distillery.Releases.Shell.writef/2","type":"function","doc":"Write the given iodata, wrapped in the given color, but bypassing the log level"},{"ref":"Distillery.Releases.Shell.html#t:verbosity/0","title":"Distillery.Releases.Shell.verbosity/0","type":"type","doc":""},{"ref":"Mix.Tasks.Distillery.Gen.Appup.html","title":"Mix.Tasks.Distillery.Gen.Appup","type":"task","doc":"Generate appup files for hot upgrades and downgrades Examples # Generate an appup for :test from the last known version to the current version mix distillery.gen.appup --app=test # Generate an appup for :test from a specific version to the current version mix distillery.gen.appup --app=test --upfrom=0.1.0 The generated appup will be written to rel/appups/&lt;app&gt;/&lt;from&gt;_to_&lt;to&gt;.appup. You may name appups anything you wish in this directory, as long as they have a .appup extension. When you build a release, the appup generator will look for missing appups in this directory structure, and scan all .appup files for matching versions. If you have multiple appup files which match the current release, then the first one encountered will take precedence, which more than likely will depend on the sort order of the names. This task will take all of the same flags as mix distillery.release, but only uses them to determine the release configuration to use when determining application locations and versions."},{"ref":"Mix.Tasks.Distillery.Gen.Appup.html#run/1","title":"Mix.Tasks.Distillery.Gen.Appup.run/1","type":"function","doc":"A task needs to implement run which receives a list of command line args. Callback implementation for Mix.Task.run/1."},{"ref":"Mix.Tasks.Distillery.Init.html","title":"Mix.Tasks.Distillery.Init","type":"task","doc":"Prepares a new project for use with releases. This simply creates a rel directory in the project root, and creates a basic initial configuration file in rel/config.exs. It will also creates a vm.args file in rel/vm.args to tweak the configuration of the BEAM. After running this, you can build a release right away with mix distillery.release, but it is recommended you review the config file to understand its contents. Examples # Initialize releases, with a fully commented config file mix distillery.init # Initialize releases, but with no comments in the config file mix distillery.init --no-doc # For umbrella projects, generate a config where each app # in the umbrella is its own release, rather than all # apps under a single release mix distillery.init --release-per-app # Name the release, by default the current application name # will be used, or in the case of umbrella projects, the name # of the directory in which the umbrella project resides, with # invalid characters replaced or stripped out. mix distillery.init --name foobar # Use a custom template for generating the release config. mix distillery.init --template path/to/template"},{"ref":"Mix.Tasks.Distillery.Init.html#get_app_name_from_ast/1","title":"Mix.Tasks.Distillery.Init.get_app_name_from_ast/1","type":"function","doc":""},{"ref":"Mix.Tasks.Distillery.Init.html#run/1","title":"Mix.Tasks.Distillery.Init.run/1","type":"function","doc":"A task needs to implement run which receives a list of command line args. Callback implementation for Mix.Task.run/1."},{"ref":"Mix.Tasks.Distillery.Release.html","title":"Mix.Tasks.Distillery.Release","type":"task","doc":"Build a release for the current mix application. Command line options --name - selects a specific release to build --env - selects a specific release environment to build with --profile - selects both a release and environment, syntax for profiles is name:env Releases and environments are defined in rel/config.exs, created via distillery.init. When determining the name and environment to use, refer to the definitions in that file if you are not sure what options are available. --erl - provide extra flags to erl when running the release, expects a string --dev - this switch indicates whether to build the release in &quot;dev mode&quot;, which symlinks build artifacts into the release rather than copying them, both significantly speeding up release builds, as well as making it possible to recompile the project and have the release pick up the changes without rebuilding the release. --silent - mutes all logging output --quiet - reduce logging output to essentials --verbose - produce detailed output about release assembly --no-tar - skip packaging the release in a tarball after assembly --warnings-as-errors - treat any release-time warnings as errors which fail the build --no-warn-missing - ignore any errors about missing applications Upgrades You can tell Distillery to build an upgrade with --upgrade. Upgrades require a source version and a target version (the current version). Distillery will automatically determine a source version by looking at previously built releases in the output directory, and selecting the most recent. If none are available, building the upgrade will fail. You can specify a specific version to upgrade from with --upfrom, which expects a version string. If the selected version cannot be found, the upgrade build will fail. Executables Distillery can build pseudo-executable files as an artifact, rather than plain tarballs. These executables are not true executables, but rather self-extracting TAR archives, which handle extraction and passing any command-line arguments to the appropriate shell scripts in the release. The following flags are used for these executables: --executable - tells Distillery to produce a self-extracting archive --transient - tells Distillery to produce a self-extracting archive which will remove the extracted contents from disk after execution Usage You are generally recommended to use rel/config.exs to configure Distillery, and simply run mix distillery.release with MIX_ENV set to the Mix environment you are targeting. The following are some usage examples: # Builds a release with MIX_ENV=dev (the default) mix distillery.release # Builds a release with MIX_ENV=prod MIX_ENV=prod mix distillery.release # Builds a release for a specific release environment MIX_ENV=prod mix distillery.release --env=dev The default configuration produced by distillery.init will result in mix distillery.release selecting the first release in the config file (rel/config.exs), and the environment which matches the current Mix environment (i.e. the value of MIX_ENV)."},{"ref":"Mix.Tasks.Distillery.Release.html#run/1","title":"Mix.Tasks.Distillery.Release.run/1","type":"function","doc":"A task needs to implement run which receives a list of command line args. Callback implementation for Mix.Task.run/1."},{"ref":"Mix.Tasks.Distillery.Release.Clean.html","title":"Mix.Tasks.Distillery.Release.Clean","type":"task","doc":"Cleans release artifacts from the current project. Examples # Cleans files associated with the latest release mix distillery.release.clean # Remove all release files mix distillery.release.clean --implode # Remove all release files, and do it without confirmation mix distillery.release.clean --implode --no-confirm # Log verbosely mix distillery.release.clean --verbose"},{"ref":"Mix.Tasks.Distillery.Release.Clean.html#run/1","title":"Mix.Tasks.Distillery.Release.Clean.run/1","type":"function","doc":"A task needs to implement run which receives a list of command line args. Callback implementation for Mix.Task.run/1."}]